searchNodes=[{"type":"module","title":"Replbug","doc":"Utility for pulling the function call traces into your IEx shell for further analysis and experimentation. The code is built on top of Rexbug ( https://github.com/nietaki/rexbug ). Motivation: Rexbug provides a convenient way of tracing function calls by printing the trace messages to IEx shell and/or the external file. In addition, Replbug allows to materialize traces as a variable, and then analyze the call data in IEx for debugging, experimentation, collecting stats etc.","ref":"Replbug.html"},{"type":"function","title":"Replbug.calls/2","doc":"Group the trace by function calls (MFA).","ref":"Replbug.html#calls/2"},{"type":"function","title":"Replbug.replay/2","doc":"Repeat the call with the same arguments. Use replay/1 with caution in prod! Also, it may not work as expected due to changes happened in between the initial call and the time of replay.","ref":"Replbug.html#replay/2"},{"type":"function","title":"Replbug.start/2","doc":"","ref":"Replbug.html#start/2"},{"type":"function","title":"Replbug.stop/0","doc":"Stop the collection and get the traces as a map of pid =&gt; trace_records","ref":"Replbug.html#stop/0"},{"type":"function","title":"Replbug.stop/1","doc":"","ref":"Replbug.html#stop/1"},{"type":"module","title":"Replbug.Server","doc":"","ref":"Replbug.Server.html"},{"type":"function","title":"Replbug.Server.lag/1","doc":"","ref":"Replbug.Server.html#lag/1"},{"type":"function","title":"Replbug.Server.start/2","doc":"","ref":"Replbug.Server.html#start/2"},{"type":"function","title":"Replbug.Server.stop/1","doc":"","ref":"Replbug.Server.html#stop/1"},{"type":"module","title":"Replbug.Utils","doc":"","ref":"Replbug.Utils.html"},{"type":"function","title":"Replbug.Utils.average_durations/1","doc":"","ref":"Replbug.Utils.html#average_durations/1"},{"type":"function","title":"Replbug.Utils.call_stats/2","doc":"","ref":"Replbug.Utils.html#call_stats/2"},{"type":"function","title":"Replbug.Utils.collect_traces/3","doc":"Collect the traces over the ` time_interval ` duration . Note : it &#39; s a blocking call , use with care","ref":"Replbug.Utils.html#collect_traces/3"},{"type":"function","title":"Replbug.Utils.counts/1","doc":"","ref":"Replbug.Utils.html#counts/1"},{"type":"function","title":"Replbug.Utils.max_args/1","doc":"","ref":"Replbug.Utils.html#max_args/1"},{"type":"function","title":"Replbug.Utils.max_duration_calls/1","doc":"","ref":"Replbug.Utils.html#max_duration_calls/1"},{"type":"function","title":"Replbug.Utils.max_returns/1","doc":"","ref":"Replbug.Utils.html#max_returns/1"},{"type":"function","title":"Replbug.Utils.mfas/1","doc":"","ref":"Replbug.Utils.html#mfas/1"},{"type":"function","title":"Replbug.Utils.min_duration_calls/1","doc":"","ref":"Replbug.Utils.html#min_duration_calls/1"},{"type":"function","title":"Replbug.Utils.summary/1","doc":"","ref":"Replbug.Utils.html#summary/1"},{"type":"function","title":"Replbug.Utils.total_durations/1","doc":"","ref":"Replbug.Utils.html#total_durations/1"},{"type":"module","title":"Rexbug.Printing","doc":"Provides the print handler and helper functions for writing custom print handlers for Rexbug . You shouldn't need to use it directly unless you want to implement a print handler yourself. See Rexbug.start/2 print_fun option for details.","ref":"Rexbug.Printing.html"},{"type":"function","title":"Rexbug.Printing.extract_stack/1","doc":"Extracts the call stack from Rexbug.Printing.Call.t/0 dump field. NOTE : The dump field will contain call stack information only if you specify &quot; :: stack&quot; in Rexbug.start/2 's trace pattern, it will be nil or empty otherwise.","ref":"Rexbug.Printing.html#extract_stack/1"},{"type":"function","title":"Rexbug.Printing.from_erl/1","doc":"Translates the :redbug tuples representing the tracing messages to Elixir structs. You can use it to implement your own custom print_fun .","ref":"Rexbug.Printing.html#from_erl/1"},{"type":"function","title":"Rexbug.Printing.print/1","doc":"The default value for the Rexbug.start/2 print_fun option. Prints out the tracing messages generated by :redbug in a nice Elixir format.","ref":"Rexbug.Printing.html#print/1"},{"type":"module","title":"Rexbug.Printing.Call","doc":"","ref":"Rexbug.Printing.Call.html"},{"type":"function","title":"Rexbug.Printing.Call.represent/2","doc":"","ref":"Rexbug.Printing.Call.html#represent/2"},{"type":"type","title":"Rexbug.Printing.Call.t/0","doc":"","ref":"Rexbug.Printing.Call.html#t:t/0"},{"type":"module","title":"Rexbug.Printing.MFA","doc":"","ref":"Rexbug.Printing.MFA.html"},{"type":"function","title":"Rexbug.Printing.MFA.from_erl/1","doc":"","ref":"Rexbug.Printing.MFA.html#from_erl/1"},{"type":"function","title":"Rexbug.Printing.MFA.represent/2","doc":"","ref":"Rexbug.Printing.MFA.html#represent/2"},{"type":"type","title":"Rexbug.Printing.MFA.t/0","doc":"","ref":"Rexbug.Printing.MFA.html#t:t/0"},{"type":"module","title":"Rexbug.Printing.Receive","doc":"","ref":"Rexbug.Printing.Receive.html"},{"type":"function","title":"Rexbug.Printing.Receive.represent/2","doc":"","ref":"Rexbug.Printing.Receive.html#represent/2"},{"type":"type","title":"Rexbug.Printing.Receive.t/0","doc":"","ref":"Rexbug.Printing.Receive.html#t:t/0"},{"type":"module","title":"Rexbug.Printing.Return","doc":"","ref":"Rexbug.Printing.Return.html"},{"type":"function","title":"Rexbug.Printing.Return.represent/2","doc":"","ref":"Rexbug.Printing.Return.html#represent/2"},{"type":"type","title":"Rexbug.Printing.Return.t/0","doc":"","ref":"Rexbug.Printing.Return.html#t:t/0"},{"type":"module","title":"Rexbug.Printing.Send","doc":"","ref":"Rexbug.Printing.Send.html"},{"type":"function","title":"Rexbug.Printing.Send.represent/2","doc":"","ref":"Rexbug.Printing.Send.html#represent/2"},{"type":"type","title":"Rexbug.Printing.Send.t/0","doc":"","ref":"Rexbug.Printing.Send.html#t:t/0"},{"type":"module","title":"Rexbug.Printing.Timestamp","doc":"","ref":"Rexbug.Printing.Timestamp.html"},{"type":"function","title":"Rexbug.Printing.Timestamp.from_erl/1","doc":"","ref":"Rexbug.Printing.Timestamp.html#from_erl/1"},{"type":"function","title":"Rexbug.Printing.Timestamp.represent/2","doc":"","ref":"Rexbug.Printing.Timestamp.html#represent/2"},{"type":"type","title":"Rexbug.Printing.Timestamp.t/0","doc":"","ref":"Rexbug.Printing.Timestamp.html#t:t/0"},{"type":"module","title":"Rexbug.Translator","doc":"Utility module for translating Elixir syntax to the one expected by :redbug . You probably don't need to use it directly.","ref":"Rexbug.Translator.html"},{"type":"function","title":"Rexbug.Translator.translate/1","doc":"Translates the Elixir trace pattern(s) (understood by Rexbug) to the Erlang trace pattern charlist(s) understood by :redbug . The translated version is not necessarily the cleanest possible, but should be correct and functionally equivalent. Example iex&gt; import Rexbug.Translator iex&gt; translate ( &quot;:cowboy.start_clear/3&quot; ) { :ok , &#39; \\&#39; cowboy \\&#39; : \\&#39; start_clear \\&#39; /3&#39; } iex&gt; translate ( &quot;MyModule.do_sth(_, [pretty: true])&quot; ) { :ok , &#39; \\&#39; Elixir.MyModule \\&#39; : \\&#39; do_sth \\&#39; (_, [{ \\&#39; pretty \\&#39; , true}])&#39; }","ref":"Rexbug.Translator.html#translate/1"},{"type":"function","title":"Rexbug.Translator.translate_options/1","doc":"Translates the options to be passed to Rexbug.start/2 to the format expected by :redbug Relevant values passed as strings will be converted to charlists.","ref":"Rexbug.Translator.html#translate_options/1"},{"type":"extras","title":"Replbug","doc":"Utilities on top of Rexbug to facilitate REPL-style debugging in IEx shell.","ref":"readme.html"},{"type":"extras","title":"Replbug - Installation","doc":"If available in Hex , the package can be installed by adding replbug to your list of dependencies in mix.exs : def deps do [ { :replbug , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Replbug - Motivation","doc":"The Erlang Trace BIFs allow to trace Erlang function calls, process messages and other events on live systems. Rexbug displays and/or writes to external files the trace messages emitted by Erlang VM in human-readable format. In many cases, this would be sufficient for the purposes of debugging the code. However, if the size and/or number of tracing messages is large, it becomes more difficult to make sense of what's going on just by visually checking the tracing output. To illustrate the issue, let's add Replbug dependency to our Phoenix server project: defp deps do [ ### Our deps... { :replbug , &quot;~&gt; 0.1&quot; } ] end and start a Phoenix server with the LiveDashboard enabled. Now start tracing Phoenix.LiveView.Plug.call/2 in IEx using Rexbug : # Start the tracing for Phoenix.LiveView.Plug.call/2 iex(1)&gt; Rexbug . start ( &quot;Phoenix.LiveView.Plug.call/2 :: return&quot; , time : 60_000 , msgs : 1_000 ) Then hit http://localhost:4000/dashboard or whatever link your LiveDashboard is configured for. We'll see a lot of output in IEx shell, which is pretty hard to comprehend due to it's size and truncations caused by pretty-printing etc.","ref":"readme.html#motivation"},{"type":"extras","title":"Replbug - Solution","doc":"Replbug preserves all functionality of Rexbug. Additionally, it allows to materialize trace records as variables that we could inspect and experiment with the collected traces in IEx shell. Let's use Replbug this time to trace the same function: # Make sure to close Rexbug session iex(2)&gt; Rexbug . stop # Start the tracing for Phoenix.LiveView.Plug.call/2 with Replbug iex(3)&gt; Replbug . start ( &quot;Phoenix.LiveView.Plug.call/2 :: return&quot; , time : 60_000 , msgs : 1_000 ) Hit http://localhost:4000/dashboard again. The same amount of output, as with using Rexbug, but now we can get the traces into IEx and inspect them programmatically: iex(3)&gt; traces = Replbug . stop ## `traces` is a map PID -&gt; calls iex(4)&gt; Map . keys ( traces ) [ # PID &lt; 0 . 544 . 0 &gt; , # PID &lt; 0 . 548 . 0 &gt; ] ## These are the processes that made the calls ## Get the list of calls across all processes iex(5)&gt; calls = Replbug . calls ( traces ) ## What calls were traced (shows the list of {Module, Function, Arity} tuples)? iex(6)&gt; Replbug.Utils . mfas ( calls ) [ { Phoenix.LiveView.Plug , :call , 2 } ] ## yeah, that&#39;s the one we traced... ## Get the call records (args, returns etc.) iex(7)&gt; call_data = Map . get ( calls , { Phoenix.LiveView.Plug , :call , 2 } ) ## What are the arguments of the first call? iex(8)&gt; [ arg1 , arg2 ] = hd ( call_data ) . args ## We expect arg1 to be a Plug.Conn struct... iex(9)&gt; iex ( 24 ) &gt; is_struct ( arg1 , Plug.Conn ) true ## ...and we are interested in user-agent value... iex(10)&gt; List . keyfind ( arg1 . req_headers , &quot;user-agent&quot; , 0 ) { &quot;user-agent&quot; , &quot;Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/104.0.0.0 Safari/537.36&quot; } ## What are durations of the calls? iex(11)&gt; durations = Enum . map ( call_data , &amp; &amp;1 . duration ) [ 9411 , 13954 ] ## Let&#39;s look at the return of the first call. iex ( 12 ) &gt; return = hd ( call_data ) . return ## We expect it to be a Plug.Conn struct as well... iex ( 13 ) &gt; is_struct ( return , Plug.Conn ) true ## Finally, check the HTTP status iex ( 14 ) &gt; return . status 302","ref":"readme.html#solution"},{"type":"extras","title":"Replbug - Status","doc":"As of now, Replbug only supports tracing of function calls. Support for tracing of inter-process messages is planned for upcoming versions.","ref":"readme.html#status"}]